using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;

namespace WCS.BLL.Tool
{
    public class Helper
    {
        private static byte[] auchCRCHi = {0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
                                    0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
                                    0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01,
                                    0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
                                    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81,
                                    0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
                                    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01,
                                    0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
                                    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
                                    0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
                                    0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01,
                                    0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
                                    0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
                                    0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
                                    0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01,
                                    0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
                                    0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81,
                                    0x40};
        private static byte[] auchCRCLo = {0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06, 0x07, 0xC7, 0x05, 0xC5, 0xC4,
                                    0x04, 0xCC, 0x0C, 0x0D, 0xCD, 0x0F, 0xCF, 0xCE, 0x0E, 0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09,
                                    0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9, 0x1B, 0xDB, 0xDA, 0x1A, 0x1E, 0xDE, 0xDF, 0x1F, 0xDD,
                                    0x1D, 0x1C, 0xDC, 0x14, 0xD4, 0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3,
                                    0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3, 0xF2, 0x32, 0x36, 0xF6, 0xF7,
                                    0x37, 0xF5, 0x35, 0x34, 0xF4, 0x3C, 0xFC, 0xFD, 0x3D, 0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A,
                                    0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38, 0x28, 0xE8, 0xE9, 0x29, 0xEB, 0x2B, 0x2A, 0xEA, 0xEE,
                                    0x2E, 0x2F, 0xEF, 0x2D, 0xED, 0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26,
                                    0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60, 0x61, 0xA1, 0x63, 0xA3, 0xA2,
                                    0x62, 0x66, 0xA6, 0xA7, 0x67, 0xA5, 0x65, 0x64, 0xA4, 0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F,
                                    0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB, 0x69, 0xA9, 0xA8, 0x68, 0x78, 0xB8, 0xB9, 0x79, 0xBB,
                                    0x7B, 0x7A, 0xBA, 0xBE, 0x7E, 0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5,
                                    0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71, 0x70, 0xB0, 0x50, 0x90, 0x91,
                                    0x51, 0x93, 0x53, 0x52, 0x92, 0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C,
                                    0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E, 0x5A, 0x9A, 0x9B, 0x5B, 0x99, 0x59, 0x58, 0x98, 0x88,
                                    0x48, 0x49, 0x89, 0x4B, 0x8B, 0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C,
                                    0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42, 0x43, 0x83, 0x41, 0x81, 0x80,
                                    0x40};
        public static byte[] Crc16(byte[] buffer, int DataLen, bool isHiLo = true)
        {
            byte uchCRCHi = 0xFF;         /* CRC 的高字节初始化 */
            byte uchCRCLo = 0xFF;         /* CRC 的低字节初始化 */
            byte uIndex = 0;              /* CRC 查询表索引 */
            ushort i = 0;                   /* buffer 数组下标 */
            while (true)                     /* 完成整个报文缓冲区 */
            {
                if (DataLen == 0)
                {
                    break;
                }
                else
                {
                    DataLen--;
                }
                uIndex = (byte)(uchCRCLo ^ buffer[i++]);
                uchCRCLo = (byte)(uchCRCHi ^ auchCRCHi[uIndex]);
                uchCRCHi = auchCRCLo[uIndex];
            }
            List<byte> data = new List<byte>() { };
            foreach (var item in buffer)
            {
                data.Add(item);
            }
            if (isHiLo)
            {
                data.Add(uchCRCHi);
                data.Add(uchCRCLo);
            }
            else
            {
                data.Add(uchCRCLo);
                data.Add(uchCRCHi);
            }
            return data.ToArray();
        }
        public static byte[] Query()
        {
            byte[] data2 = new byte[4];
            data2[0] = 0xff;
            data2[1] = 0x03;
            data2[2] = 0x00;
            data2[3] = 0x06;
            byte[] senddata2 = Tool.Helper.Crc16(data2, data2.Length, true);
            return senddata2;
        }
        public static byte[] SetId()
        {
            byte[] data2 = new byte[6];
            data2[0] = 0xff;
            data2[1] = 0x04;
            data2[2] = 0x00;
            data2[3] = 0x08;
            data2[4] = 0x03;
            data2[5] = 0x01;
            byte[] senddata2 = Tool.Helper.Crc16(data2, data2.Length, true);
            return senddata2;
        }
        //出库库位灯亮灯
        public static byte[] OutstoreLight(List<int> board_id, string lightcolor, int status)
        {
            byte color = 0x00;
            switch (lightcolor)
            {
                case "红":
                    color = 0x01;
                    break;
                case "绿":
                    color = 0x02;
                    break;
                case "黄":
                    color = 0x03;
                    break;
                case "蓝":
                    color = 0x04;
                    break;
                case "紫":
                    color = 0x05;
                    break;
                case "青":
                    color = 0x06;
                    break;
                case "白":
                    color = 0x07;
                    break;
                case "无":
                    color = 0x00;
                    break;
            }
            byte[] data1 = new byte[3 * board_id.Count + 5];
            data1[0] = 0xff;
            data1[1] = 0x01;
            byte[] length_base = BitConverter.GetBytes(data1.Length + 2);
            data1[2] = length_base[1];
            data1[3] = length_base[0];
            data1[4] = (byte)board_id.Count;
            for (int i = 0; i < board_id.Count; i++)
            {
                data1[5 + i * 3] = (byte)board_id[i];
                data1[5 + i * 3 + 1] = (byte)status;
                data1[5 + i * 3 + 2] = color;
            }
            byte[] data = Crc16(data1, data1.Length, true);
            return data;
        }
        //出库警示灯亮灯
        public static byte[] OutstoreWarnLight(int lightid, string lightcolor, int status, int beestatus)
        {
            byte color = 0x00;
            switch (lightcolor)
            {
                case "红":
                    color = 0x01;
                    break;
                case "绿":
                    color = 0x02;
                    break;
                case "黄":
                    color = 0x03;
                    break;
                case "蓝":
                    color = 0x04;
                    break;
                case "紫":
                    color = 0x05;
                    break;
                case "青":
                    color = 0x06;
                    break;
                case "白":
                    color = 0x07;
                    break;
                case "无":
                    color = 0x00;
                    break;
            }
            byte[] data1 = new byte[5 + 3 * 6];
            data1[0] = 0xff;
            data1[1] = 0x01;
            data1[2] = 0x00;
            data1[3] = (byte)(data1.Length + 2);
            data1[4] = 0x06;
            for (int i = 0; i < 6; i++)
            {
                data1[5 + i * 3] = (byte)(lightid + i);
                data1[6 + i * 3] = (byte)status;
                data1[7 + i * 3] = color;
            }

            byte[] data2 = Crc16(data1, data1.Length, true);
            return data2;
        }

        //入库库位灯短亮（绿色）
        public static byte[] InstoreLight(int board_id)
        {
            byte[] data2 = new byte[8];
            data2[0] = 0xff;
            data2[1] = 0x01;
            data2[2] = 0x00;
            data2[3] = 0x0a;
            data2[4] = 0x01;
            data2[5] = (byte)board_id;
            data2[6] = 0x03;
            data2[7] = 0x02;
            byte[] senddata2 = Tool.Helper.Crc16(data2, data2.Length, true);
            return senddata2;
        }

        //入库警示灯短亮（绿色），蜂鸣器鸣叫一次
        public static byte[] InstoreWarnLight(int lightid)
        {
            byte[] data1 = new byte[5 + 3 * 7];
            data1[0] = 0xff;
            data1[1] = 0x01;
            data1[2] = 0x00;
            data1[3] = (byte)(data1.Length + 2);
            data1[4] = 0x07;
            //7就是带的有蜂鸣器
            for (int i = 0; i < 7; i++)
            {
                data1[5 + i * 3] = (byte)(lightid + i);
                data1[6 + i * 3] = 0x03;
                data1[7 + i * 3] = 0x02;
            }

            byte[] senddata1 = Tool.Helper.Crc16(data1, data1.Length, true);
            return senddata1;
        }
        public static byte[] InstoreLightAndWarnLight(int board_id, int lightid)
        {
            byte[] data1 = new byte[8 + 3 * 7];
            data1[0] = 0xff;
            data1[1] = 0x01;
            data1[2] = 0x00;
            data1[3] = (byte)(data1.Length + 2);
            data1[4] = 0x08;

            //库位灯
            data1[5] = (byte)board_id;
            data1[6] = 0x03;
            data1[7] = 0x02;

            //7就是带的有蜂鸣器
            for (int i = 0; i < 7; i++)
            {
                data1[8 + i * 3] = (byte)(lightid + i);
                data1[9 + i * 3] = 0x03;
                data1[10 + i * 3] = 0x02;
            }

            byte[] senddata1 = Tool.Helper.Crc16(data1, data1.Length, true);
            return senddata1;
        }

        //出库确认 蜂鸣器鸣叫一次
        public static byte[] CommitOutstoreBee(int lightid)
        {
            byte[] data1 = new byte[5 + 3 * 1];
            data1[0] = 0xff;
            data1[1] = 0x01;
            data1[2] = 0x00;
            data1[3] = (byte)(data1.Length + 2);
            data1[4] = 0x01;

            data1[5] = (byte)(lightid + 6);
            data1[6] = 0x03;
            data1[7] = 0x02;

            byte[] sendData = Tool.Helper.Crc16(data1, data1.Length, true);
            return sendData;
        }


        /// <summary>
        /// 库位灯常亮/关闭
        /// </summary>
        /// <param name="board_id"></param>
        /// <param name="lightcolor"></param>
        /// <param name="status">0X00 关闭   0X01 常亮   0X02 闪烁   0X03 短亮一次</param>
        /// <returns></returns>
        public static byte[] StoreLightOnOff(int board_id, string lightcolor, int status)
        {
            byte color = 0x00;
            switch (lightcolor)
            {
                case "红":
                    color = 0x01;
                    break;
                case "绿":
                    color = 0x02;
                    break;
                case "黄":
                    color = 0x03;
                    break;
                case "蓝":
                    color = 0x04;
                    break;
                case "紫":
                    color = 0x05;
                    break;
                case "青":
                    color = 0x06;
                    break;
                case "白":
                    color = 0x07;
                    break;
                case "无":
                    color = 0x00;
                    break;
            }
            byte[] data1 = new byte[3 + 5];
            data1[0] = 0xff;
            data1[1] = 0x01;
            byte[] length_base = BitConverter.GetBytes(data1.Length + 2);
            data1[2] = length_base[1];
            data1[3] = length_base[0];
            data1[4] = 0x01;

            data1[5] = (byte)board_id;
            data1[5 + 1] = (byte)status;
            data1[5 + 2] = color;

            byte[] data = Crc16(data1, data1.Length, true);
            return data;
        }

        /// <summary>
        /// 单灯货架控制
        /// </summary>
        /// <param name="board_id"></param>
        /// <param name="lightcolor"></param>
        /// <param name="status"></param>
        /// <returns></returns>
        public static byte[] SingleLightControl(List<SingleLightShelfModel> shelfs)
        {
            byte[] dataBase = new byte[5];
            dataBase[0] = 0xff;
            dataBase[1] = 0x01;

            //一个报警灯一个货架
            var lightCount = 0;
            foreach (var shelf in shelfs)
            {
                //6个报警灯需要发送指令

                if (shelf.WarningLightMode != -1)
                {
                    for (int i = 0; i < 6; i++)
                    {
                        var singleLightData = GenerateSingleLightData(shelf.WarningBoardId + i, shelf.WarningLightMode, shelf.WarningLightColor);
                        lightCount++;
                        dataBase = dataBase.Concat(singleLightData).ToArray();
                    }
                }
                //蜂鸣器需要发送指令
                if (shelf.WarningBuzzerMode != -1)
                {
                    var singleLightData = GenerateSingleLightData(shelf.WarningBoardId + 6, shelf.WarningBuzzerMode, shelf.WarningLightColor);
                    lightCount++;
                    dataBase = dataBase.Concat(singleLightData).ToArray();
                }

                //库位灯指令
                if (shelf.StoreList != null && shelf.StoreList.Count > 0)
                {
                    foreach (var store in shelf.StoreList)
                    {
                        var singleLightData = GenerateSingleLightData(store.BoardId, store.LightMode, store.LightColor);
                        lightCount++;
                        dataBase = dataBase.Concat(singleLightData).ToArray();
                    }
                }
            }

            byte[] length_base = BitConverter.GetBytes(dataBase.Length + 2);
            dataBase[2] = length_base[1];
            dataBase[3] = length_base[0];
            //控制灯的数量
            dataBase[4] = (byte)lightCount;

            byte[] dataWithCRC = Crc16(dataBase, dataBase.Length, true);
            return dataWithCRC;
        }
        //单独拼接一个灯的协议
        public static byte[] GenerateSingleLightData(int lightId, int lightMode, int lightColor)
        {
            var data = new byte[3];

            data[0] = (byte)lightId;
            data[1] = (byte)lightMode;
            data[2] = (byte)lightColor;

            return data;
        }

        public class SingleLightShelfModel
        {
            public string ClientIp { get; set; } = string.Empty;
            public int WarningBoardId { get; set; }
            public int WarningLightMode { get; set; }
            public int WarningBuzzerMode { get; set; }
            public int WarningLightColor { get; set; }
            public List<SingleLightStoreModel> StoreList { get; set; } = new List<SingleLightStoreModel>();
        }

        public class SingleLightStoreModel
        {
            public int BoardId { get; set; }
            public int LightMode { get; set; }
            public int LightColor { get; set; }
        }

        /// <summary>
        /// 返回数据处理
        /// </summary>
        public static void ReturnDataProcess(TCPClient tcpClient, byte[] returnData)
        {
            if (returnData[0] == 0xFF && returnData[1] == 0x00 && returnData[3] == 0x08
            && returnData[4] == 0x01 && returnData[5] == 0x06)
            {
                var sendData = Query();
                tcpClient.Send(sendData);
                return;
            }
        }

        public static byte[] OutstoreWarnLight_1(int lightid, string lightcolor, int status, int beestatus)
        {
            byte color = 0x00;
            switch (lightcolor)
            {
                case "红":
                    color = 0x01;
                    break;
                case "绿":
                    color = 0x02;
                    break;
                case "黄":
                    color = 0x03;
                    break;
                case "蓝":
                    color = 0x04;
                    break;
                case "紫":
                    color = 0x05;
                    break;
                case "青":
                    color = 0x06;
                    break;
                case "白":
                    color = 0x07;
                    break;
                case "无":
                    color = 0x00;
                    break;
            }
            byte[] data1 = new byte[5 + 3 * 6];
            data1[0] = 0xff;
            data1[1] = 0x01;
            data1[2] = 0x00;
            data1[3] = (byte)(data1.Length + 2);
            data1[4] = 0x06;
            for (int i = 0; i < 6; i++)
            {
                data1[5 + i * 3] = (byte)(lightid + i);
                data1[6 + i * 3] = (byte)status;
                data1[7 + i * 3] = color;
            }
            //dataBase[5 + 3 * 7 - 3] = (byte)(lightid + 6);
            //dataBase[5 + 3 * 7 - 2] =(byte)beestatus;
            //dataBase[5 + 3 * 7 - 1] = 0x00;
            byte[] data2 = Crc16(data1, data1.Length, true);
            return data2;
        }
    }
}
